/* 
Unlimited Simulator is copyrighted (c) Bruno Barberi Gnecco, 1999, and
distributed under the GNU General Public License (GPL). The conditions can be
found in the file GPL, resident at the main directory of the distribution.
*/

/* This file, netio.c, is adapted from original code by Steve Kirkendall.
Permission given. */

/* This file contains functions for accessing the internet.
 *
 *   void netclose(int *sock);
 *	Close a socket connection which was created via nropen() or nrbind()
 *
 *   int netread(int sock, char *buf, int nbytes);
 *	Read bytes from sb's socket.  Returns True if successful (even if
 *	no data has been read, at the end of input), or False if error or
 *	user-abort (after giving an error message).
 *
 *   int netwrite(int sock, char *buf, int nbytes);
 *	Write data to sb's socket.  Returns True if successful.
 *
 */

#include "unlimited.h"
#include <stdio.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/socket.h>

/* close a socket which was opened by netconnect */
void netclose( int sock ) {
	close( sock );
}


/* Read as much data as possible from a socket */
int netread ( int sock, char *buf, int nbytes ) {
	return read( sock, buf, nbytes );
}


/* Write data to the socket */
int netwrite ( int sock, char *buf, int nbytes ) {
	int	nsent;
	nsent = write( sock, buf, nbytes );
	if ( nsent != nbytes && nsent != -1 ) {
		fprintf( stderr, 
	   "netwrite: tried to send %d bytes to socket %d, actually sent %d\n",
				 nbytes, sock, nsent );
		return (int)False;
	}
	return (int)True;
}
