#define CLIENT 1
#include "ulengine.h"
#include <unistd.h>
#include <sys/time.h>

CAMERA_UL cam;
POLY_UL *cface[7];
POLY_UL *tface[5];
VECTOR_UL cube[8] = { { 0,0,0 }, { 0,0,1 }, { 0,1,0 }, { 1,0,0 },
		{ 1,1,0 }, { 0,1,1 }, { 1,0,1 }, { 1,1,1 } };
VECTOR_UL tetra[4] = { { 0,0,0 }, { 0,1,0 }, { 0.5,0.866,0 }, {0.5,0.433,0.707 } };
VECTOR_UL triv[3] = { { 100, 100, 0 }, { 200, 50, 0 }, { 150, 200, 0 } };
TRI_UL *mytri;
POINT_UL tetrap[4];

int main( ) {
	ggi_color red = { 0xFFFF, 0, 0, 0 }, green = { 0, 0xFFFF, 0, 0 },
		blue = { 0, 0, 0xFFFF, 0 }, *color[3];
	POINT_UL *tri[3];
	int i;
	struct timeval	tv1, tv2;

	if ( initULEngine( 0, 0, 0, False, False ) != OK ) {
		fprintf( stderr, "Damn!\n" );
		return 1;
	}

/*	cface[0] = createPolyPV( 4, True, &red, cube[0], cube[3], cube[4], cube[2]);
	cface[1] = createPolyPV( 4, True, &red, cube[1], cube[5], cube[7], cube[6]);
	cface[2] = createPolyPV( 4, True, &green, cube[0], cube[1], cube[6], cube[3]);
	cface[3] = createPolyPV( 4, True, &green, cube[2], cube[4], cube[7], cube[5]);
	cface[4] = createPolyPV( 4, True, &blue, cube[3], cube[6], cube[7], cube[4]);
	cface[5] = createPolyPV( 4, True, &blue, cube[1], cube[0], cube[2], cube[5]);
	cface[6] = NULL; 
	createDoodadP( "cube", *cface ); */
			
	tetrap[0].vect = &tetra[0];
	tetrap[1].vect = &tetra[1];
	tetrap[2].vect = &tetra[2];
	tetrap[3].vect = &tetra[3];
	tri[0] = &tetrap[0]; tri[1] = &tetrap[1]; tri[2] = &tetrap[2];
	tface[0] = createPolyP( 3, True, &red, *tri );
	tri[0] = &tetrap[0]; tri[1] = &tetrap[3]; tri[2] = &tetrap[1];
	tface[1] = createPolyP( 3, True, &red, *tri );
	tri[0] = &tetrap[0]; tri[1] = &tetrap[2]; tri[2] = &tetrap[3];
	tface[2] = createPolyP( 3, True, &green, *tri );
	tri[0] = &tetrap[1]; tri[1] = &tetrap[3]; tri[2] = &tetrap[2];
	tface[3] = createPolyP( 3, True, &blue, *tri );
	tface[4] = NULL; 
	tface[0]->flatcolor = &tface[0]->color[0];
	tface[1]->flatcolor = &tface[1]->color[0];
	tface[2]->flatcolor = &tface[2]->color[0];
	tface[3]->flatcolor = &tface[3]->color[0];
	createDoodadP( NULL, tface );
	
	setCameraD( &cam, 3,3,3, -1,-1,-1, 0 );
	setCameraZ( &cam, 0, -1 );
#ifdef hahae
	/* test drawHLine */
	ggiSetGCForeground( vis, white );
	ggiPuts( vis, 0, 0, "Testing drawHLine" );
	drawHLine( 10, 250, 150, 0, 0, &green, &red );
	putImage();
	sleep(2);

	/* test drawLine & zbuffer */
	ggiSetGCForeground( vis, black );
	ggiFillscreen( vis );
	ggiSetGCForeground( vis, white );
	ggiPuts( vis, 0, 0, "Testing drawLine and zbuffer" );
	drawLine( 10, 300, 10, 300, 10, 10, &blue, &red );
	drawLine( 10, 10, 100, 300, 300, 100, &red, &green );
	putImage();
	sleep(2);

	/* test drawFlatTri & createpoly */
	ggiSetGCForeground( vis, black );
	ggiFillscreen( vis );
	ggiSetGCForeground( vis, white );
	ggiPuts( vis, 0, 0, "Testing drawFlatTri and createPoly" );
	
	tetrap[0].vect = &triv[0];	tetrap[1].vect = &triv[1];
	tetrap[2].vect = &triv[2];
	mytri = createPolyP( 3, True, &blue, tetrap );
	drawFlatTri( mytri );
	
	putImage();
	sleep(2);
	freePoly( mytri );   

	/* test drawGouraudTri */
	ggiSetGCForeground( vis, black );
	ggiFillscreen( vis );
	ggiSetGCForeground( vis, white );
	ggiPuts( vis, 0, 0, "Testing drawGouraudTri" );
	
	tetrap[0].vect = &triv[0];	tetrap[1].vect = &triv[1];
	tetrap[2].vect = &triv[2];
	color[0] = &blue;
	color[1] = &green;
	color[2] = &red;
	mytri = createPolyP( 3, False, *color, tetrap );
	drawShadedTri( mytri );
	putImage();
	freePoly( mytri );   
#endif

	/* test rendering */
	ggiSetGCForeground( vis, black );
	ggiFillscreen( vis );
	ggiSetGCForeground( vis, white );
	ggiPuts( vis, 0, 0, "Testing rendering" );
	render( &cam );
	sleep(2);

	endULEngine( );
}
